Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4497)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4498)
@@ -2196,60 +2061,59 @@
           variable_name = TRIM( vmea(l)%var_atts(n)%name )
 !
-!--       In order to link the correct dimension names, atmosphere and soil
-!--       variables need to be distinguished.
-          IF ( vmea(l)%soil_sampling  .AND.                                    &
+!--       In order to link the correct dimension names, atmosphere and soil variables need to be
+!--       distinguished.
+          IF ( vmea(l)%soil_sampling  .AND.                                                        &
                ANY( TRIM( vmea(l)%var_atts(n)%name) == soil_vars ) )  THEN
 
-             return_value = dom_def_var( vmea(l)%nc_filename,                  &
-                                         variable_name = variable_name,        &
-                                         dimension_names = (/'station_soil',   &
-                                                             'ntime_soil  '/), &
+             return_value = dom_def_var( vmea(l)%nc_filename,                                      &
+                                         variable_name = variable_name,                            &
+                                         dimension_names = (/'station_soil',                       &
+                                                             'ntime_soil  '/),                     &
                                          output_type = 'real32' )
           ELSE
 
-             return_value = dom_def_var( vmea(l)%nc_filename,                  &
-                                         variable_name = variable_name,        &
-                                         dimension_names = (/'station',        &
-                                                             'ntime  '/),      &
+             return_value = dom_def_var( vmea(l)%nc_filename,                                      &
+                                         variable_name = variable_name,                            &
+                                         dimension_names = (/'station',                            &
+                                                             'ntime  '/),                          &
                                          output_type = 'real32' )
           ENDIF
 !
-!--       Set variable attributes. Please note, for some variables not all
-!--       attributes are defined, e.g. standard_name for the horizontal wind
-!--       components.
+!--       Set variable attributes. Please note, for some variables not all attributes are defined,
+!--       e.g. standard_name for the horizontal wind components.
           CALL vm_set_attributes( vmea(l)%var_atts(n) )
 
           IF ( vmea(l)%var_atts(n)%long_name /= 'none' )  THEN
-             return_value = dom_def_att( vmea(l)%nc_filename,                  &
-                                         variable_name = variable_name,        &
-                                         attribute_name = char_long,           &
+             return_value = dom_def_att( vmea(l)%nc_filename,                                      &
+                                         variable_name = variable_name,                            &
+                                         attribute_name = char_long,                               &
                                          value = TRIM( vmea(l)%var_atts(n)%long_name ) )
           ENDIF
           IF ( vmea(l)%var_atts(n)%standard_name /= 'none' )  THEN
-             return_value = dom_def_att( vmea(l)%nc_filename,                  &
-                                         variable_name = variable_name,        &
-                                         attribute_name = char_standard,       &
+             return_value = dom_def_att( vmea(l)%nc_filename,                                      &
+                                         variable_name = variable_name,                            &
+                                         attribute_name = char_standard,                           &
                                          value = TRIM( vmea(l)%var_atts(n)%standard_name ) )
           ENDIF
           IF ( vmea(l)%var_atts(n)%units /= 'none' )  THEN
-             return_value = dom_def_att( vmea(l)%nc_filename,                  &
-                                         variable_name = variable_name,        &
-                                         attribute_name = char_unit,           &
+             return_value = dom_def_att( vmea(l)%nc_filename,                                      &
+                                         variable_name = variable_name,                            &
+                                         attribute_name = char_unit,                               &
                                          value = TRIM( vmea(l)%var_atts(n)%units ) )
           ENDIF
 
-          return_value = dom_def_att( vmea(l)%nc_filename,                     &
-                                      variable_name = variable_name,           &
-                                      attribute_name = 'grid_mapping',         &
+          return_value = dom_def_att( vmea(l)%nc_filename,                                         &
+                                      variable_name = variable_name,                               &
+                                      attribute_name = 'grid_mapping',                             &
                                       value = TRIM( vmea(l)%var_atts(n)%grid_mapping ) )
 
-          return_value = dom_def_att( vmea(l)%nc_filename,                     &
-                                      variable_name = variable_name,           &
-                                      attribute_name = 'coordinates',          &
+          return_value = dom_def_att( vmea(l)%nc_filename,                                         &
+                                      variable_name = variable_name,                               &
+                                      attribute_name = 'coordinates',                              &
                                       value = TRIM( vmea(l)%var_atts(n)%coordinates ) )
 
-          return_value = dom_def_att( vmea(l)%nc_filename,                     &
-                                      variable_name = variable_name,           &
-                                      attribute_name = char_fill,              &
+          return_value = dom_def_att( vmea(l)%nc_filename,                                         &
+                                      variable_name = variable_name,                               &
+                                      attribute_name = char_fill,                                  &
                                       value = REAL( vmea(l)%var_atts(n)%fill_value, KIND=4 ) )
 
@@ -2261,13 +2125,13 @@
  END SUBROUTINE vm_init_output
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Parallel NetCDF output via data-output module.
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE vm_data_output
 
-    CHARACTER(LEN=100) ::  variable_name !< name of output variable
-    CHARACTER(LEN=maximum_name_length), DIMENSION(:), ALLOCATABLE :: station_name !< string for station name, consecutively ordered
+    CHARACTER(LEN=100) ::  variable_name  !< name of output variable
+    CHARACTER(LEN=maximum_name_length), DIMENSION(:), ALLOCATABLE :: station_name  !< string for station name, consecutively ordered
 
     CHARACTER(LEN=1), DIMENSION(:,:), ALLOCATABLE, TARGET ::  output_values_2d_char_target  !< target for output name arrays
@@ -2278,12 +2142,11 @@
     INTEGER(iwp)       ::  nn            !< loop index for number of characters in a name
     INTEGER            ::  return_value  !< returned status value of called function
-
     INTEGER(iwp)       ::  t_ind         !< time index
 
-    REAL(wp), DIMENSION(:), ALLOCATABLE           ::  oro_rel                  !< relative altitude of model surface
-    REAL(wp), DIMENSION(:), POINTER               ::  output_values_1d_pointer !< pointer for 1d output array
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET   ::  output_values_1d_target  !< target for 1d output array
-    REAL(wp), DIMENSION(:,:), POINTER             ::  output_values_2d_pointer !< pointer for 2d output array
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET ::  output_values_2d_target  !< target for 2d output array
+    REAL(wp), DIMENSION(:), ALLOCATABLE           ::  oro_rel                   !< relative altitude of model surface
+    REAL(wp), DIMENSION(:), POINTER               ::  output_values_1d_pointer  !< pointer for 1d output array
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET   ::  output_values_1d_target   !< target for 1d output array
+    REAL(wp), DIMENSION(:,:), POINTER             ::  output_values_2d_pointer  !< pointer for 2d output array
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET ::  output_values_2d_target   !< target for 2d output array
 
     CALL cpu_log( log_point_s(26), 'VM output', 'start' )
@@ -2301,37 +2164,36 @@
 !
 !--       Output of Easting coordinate. Before output, recalculate EUTM.
-          output_values_1d_target = init_model%origin_x                        &
-                    + REAL( vmea(l)%i(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dx &
-                    * COS( init_model%rotation_angle * pi / 180.0_wp )         &
-                    + REAL( vmea(l)%j(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dy &
+          output_values_1d_target = init_model%origin_x                                            &
+                    + REAL( vmea(l)%i(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dx                     &
+                    * COS( init_model%rotation_angle * pi / 180.0_wp )                             &
+                    + REAL( vmea(l)%j(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dy                     &
                     * SIN( init_model%rotation_angle * pi / 180.0_wp )
 
           output_values_1d_pointer => output_values_1d_target
 
-          return_value =                                                       &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'E_UTM',                                      &
-                                 values_realwp_1d = output_values_1d_pointer,  &
-                                 bounds_start = (/vmea(l)%start_coord_a/),     &
+          return_value =                                                                           &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'E_UTM',                                                          &
+                                 values_realwp_1d = output_values_1d_pointer,                      &
+                                 bounds_start = (/vmea(l)%start_coord_a/),                         &
                                  bounds_end   = (/vmea(l)%end_coord_a  /) )
 !
 !--       Output of Northing coordinate. Before output, recalculate NUTM.
-          output_values_1d_target = init_model%origin_y                        &
-                    - REAL( vmea(l)%i(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dx &
-                    * SIN( init_model%rotation_angle * pi / 180.0_wp )         &
-                    + REAL( vmea(l)%j(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dy &
+          output_values_1d_target = init_model%origin_y                                            &
+                    - REAL( vmea(l)%i(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dx                     &
+                    * SIN( init_model%rotation_angle * pi / 180.0_wp )                             &
+                    + REAL( vmea(l)%j(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dy                     &
                     * COS( init_model%rotation_angle * pi / 180.0_wp )
 
           output_values_1d_pointer => output_values_1d_target
-          return_value =                                                       &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'N_UTM',                                      &
-                                 values_realwp_1d = output_values_1d_pointer,  &
-                                 bounds_start = (/vmea(l)%start_coord_a/),     &
+          return_value =                                                                           &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'N_UTM',                                                          &
+                                 values_realwp_1d = output_values_1d_pointer,                      &
+                                 bounds_start = (/vmea(l)%start_coord_a/),                         &
                                  bounds_end   = (/vmea(l)%end_coord_a  /) )
 !
 !--       Output of relative height coordinate.
-!--       Before this is output, first define the relative orographie height
-!--       and add this to z.
+!--       Before this is output, first define the relative orographie height and add this to z.
           ALLOCATE( oro_rel(1:vmea(l)%ns) )
           DO  n = 1, vmea(l)%ns
@@ -2341,21 +2203,20 @@
           output_values_1d_target = vmea(l)%zar(1:vmea(l)%ns) + oro_rel(:)
           output_values_1d_pointer => output_values_1d_target
-          return_value =                                                       &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'z',                                          &
-                                 values_realwp_1d = output_values_1d_pointer,  &
-                                 bounds_start = (/vmea(l)%start_coord_a/),     &
+          return_value =                                                                           &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'z',                                                              &
+                                 values_realwp_1d = output_values_1d_pointer,                      &
+                                 bounds_start = (/vmea(l)%start_coord_a/),                         &
                                  bounds_end   = (/vmea(l)%end_coord_a  /) )
 !
-!--       Write surface altitude for the station. Note, since z is already
-!--       a relative observation height, station_h must be zero, in order
-!--       to obtain the observation level.
+!--       Write surface altitude for the station. Note, since z is already a relative observation
+!--       height, station_h must be zero, in order to obtain the observation level.
           output_values_1d_target = oro_rel(:)
           output_values_1d_pointer => output_values_1d_target
-          return_value =                                                       &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'station_h',                                  &
-                                 values_realwp_1d = output_values_1d_pointer,  &
-                                 bounds_start = (/vmea(l)%start_coord_a/),     &
+          return_value =                                                                           &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'station_h',                                                      &
+                                 values_realwp_1d = output_values_1d_pointer,                      &
+                                 bounds_start = (/vmea(l)%start_coord_a/),                         &
                                  bounds_end   = (/vmea(l)%end_coord_a  /) )
 
@@ -2378,9 +2239,9 @@
           output_values_2d_char_pointer => output_values_2d_char_target
 
-          return_value =                                                       &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'station_name',                               &
-                                 values_char_2d = output_values_2d_char_pointer,&
-                                 bounds_start = (/ 1,                   vmea(l)%start_coord_a /),&
+          return_value =                                                                           &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'station_name',                                                   &
+                                 values_char_2d = output_values_2d_char_pointer,                   &
+                                 bounds_start = (/ 1,                   vmea(l)%start_coord_a /),  &
                                  bounds_end   = (/ maximum_name_length, vmea(l)%end_coord_a /) )
 
@@ -2388,41 +2249,39 @@
           DEALLOCATE( output_values_2d_char_target )
 !
-!--       In case of sampled soil quantities, output also the respective
-!--       coordinate arrays.
+!--       In case of sampled soil quantities, output also the respective coordinate arrays.
           IF ( vmea(l)%soil_sampling )  THEN
              ALLOCATE( output_values_1d_target(vmea(l)%start_coord_s:vmea(l)%end_coord_s) )
 !
 !--          Output of Easting coordinate. Before output, recalculate EUTM.
-             output_values_1d_target = init_model%origin_x                     &
-               + REAL( vmea(l)%i(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dx &
-               * COS( init_model%rotation_angle * pi / 180.0_wp )              &
-               + REAL( vmea(l)%j(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dy &
+             output_values_1d_target = init_model%origin_x                                         &
+               + REAL( vmea(l)%i(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dx                     &
+               * COS( init_model%rotation_angle * pi / 180.0_wp )                                  &
+               + REAL( vmea(l)%j(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dy                     &
                * SIN( init_model%rotation_angle * pi / 180.0_wp )
              output_values_1d_pointer => output_values_1d_target
-             return_value =                                                    &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'E_UTM_soil',                                 &
-                                 values_realwp_1d = output_values_1d_pointer,  &
-                                 bounds_start = (/vmea(l)%start_coord_s/),     &
+             return_value =                                                                        &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'E_UTM_soil',                                                     &
+                                 values_realwp_1d = output_values_1d_pointer,                      &
+                                 bounds_start = (/vmea(l)%start_coord_s/),                         &
                                  bounds_end   = (/vmea(l)%end_coord_s  /) )
 !
 !--          Output of Northing coordinate. Before output, recalculate NUTM.
-             output_values_1d_target = init_model%origin_y                     &
-               - REAL( vmea(l)%i(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dx &
-               * SIN( init_model%rotation_angle * pi / 180.0_wp )              &
-               + REAL( vmea(l)%j(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dy &
+             output_values_1d_target = init_model%origin_y                                         &
+               - REAL( vmea(l)%i(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dx                     &
+               * SIN( init_model%rotation_angle * pi / 180.0_wp )                                  &
+               + REAL( vmea(l)%j(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dy                     &
                * COS( init_model%rotation_angle * pi / 180.0_wp )
 
              output_values_1d_pointer => output_values_1d_target
-             return_value =                                                    &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'N_UTM_soil',                                 &
-                                 values_realwp_1d = output_values_1d_pointer,  &
-                                 bounds_start = (/vmea(l)%start_coord_s/),     &
+             return_value =                                                                        &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'N_UTM_soil',                                                     &
+                                 values_realwp_1d = output_values_1d_pointer,                      &
+                                 bounds_start = (/vmea(l)%start_coord_s/),                         &
                                  bounds_end   = (/vmea(l)%end_coord_s  /) )
 !
 !--          Output of relative height coordinate.
-!--          Before this is output, first define the relative orographie height
-!--          and add this to z.
+!--          Before this is output, first define the relative orographie height and add this to z.
              ALLOCATE( oro_rel(1:vmea(l)%ns_soil) )
              DO  n = 1, vmea(l)%ns_soil
@@ -2432,21 +2291,20 @@
              output_values_1d_target = vmea(l)%depth(1:vmea(l)%ns_soil) + oro_rel(:)
              output_values_1d_pointer => output_values_1d_target
-             return_value =                                                    &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'z_soil',                                     &
-                                 values_realwp_1d = output_values_1d_pointer,  &
-                                 bounds_start = (/vmea(l)%start_coord_s/),     &
+             return_value =                                                                        &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'z_soil',                                                         &
+                                 values_realwp_1d = output_values_1d_pointer,                      &
+                                 bounds_start = (/vmea(l)%start_coord_s/),                         &
                                  bounds_end   = (/vmea(l)%end_coord_s  /) )
 !
-!--          Write surface altitude for the station. Note, since z is already
-!--          a relative observation height, station_h must be zero, in order
-!--          to obtain the observation level.
+!--          Write surface altitude for the station. Note, since z is already a relative observation
+!--          height, station_h must be zero, in order to obtain the observation level.
              output_values_1d_target = oro_rel(:)
              output_values_1d_pointer => output_values_1d_target
-             return_value =                                                    &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'station_h_soil',                             &
-                                 values_realwp_1d = output_values_1d_pointer,  &
-                                 bounds_start = (/vmea(l)%start_coord_s/),     &
+             return_value =                                                                        &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'station_h_soil',                                                 &
+                                 values_realwp_1d = output_values_1d_pointer,                      &
+                                 bounds_start = (/vmea(l)%start_coord_s/),                         &
                                  bounds_end   = (/vmea(l)%end_coord_s  /) )
 
@@ -2456,5 +2314,5 @@
 !--          Write station name
              ALLOCATE ( station_name(vmea(l)%start_coord_s:vmea(l)%end_coord_s) )
-             ALLOCATE ( output_values_2d_char_target(vmea(l)%start_coord_s:vmea(l)%end_coord_s, &
+             ALLOCATE ( output_values_2d_char_target(vmea(l)%start_coord_s:vmea(l)%end_coord_s,    &
                                                      1:maximum_name_length) )
 
@@ -2468,9 +2326,9 @@
              output_values_2d_char_pointer => output_values_2d_char_target
 
-             return_value =                                                    &
-                  dom_write_var( vmea(l)%nc_filename,                          &
-                                 'station_name_soil',                          &
-                                 values_char_2d = output_values_2d_char_pointer,&
-                                 bounds_start = (/ 1,                   vmea(l)%start_coord_s /),&
+             return_value =                                                                        &
+                  dom_write_var( vmea(l)%nc_filename,                                              &
+                                 'station_name_soil',                                              &
+                                 values_char_2d = output_values_2d_char_pointer,                   &
+                                 bounds_start = (/ 1,                   vmea(l)%start_coord_s /),  &
                                  bounds_end   = (/ maximum_name_length, vmea(l)%end_coord_s   /) )
 
@@ -2496,5 +2354,5 @@
 !--    Write output variables. Distinguish between atmosphere and soil variables.
        DO  n = 1, vmea(l)%nmeas
-          IF ( vmea(l)%soil_sampling  .AND.                                    &
+          IF ( vmea(l)%soil_sampling  .AND.                                                        &
             ANY( TRIM( vmea(l)%var_atts(n)%name) == soil_vars ) )  THEN
 !
@@ -2505,8 +2363,8 @@
              output_values_2d_pointer => output_values_2d_target
 
-             return_value = dom_write_var( vmea(l)%nc_filename,                &
-                                           variable_name,                      &
+             return_value = dom_write_var( vmea(l)%nc_filename,                                    &
+                                           variable_name,                                          &
                                            values_realwp_2d = output_values_2d_pointer, &
-                                           bounds_start = (/vmea(l)%start_coord_s, t_ind/), &
+                                           bounds_start = (/vmea(l)%start_coord_s, t_ind/),        &
                                            bounds_end   = (/vmea(l)%end_coord_s, t_ind /) )
 
@@ -2514,9 +2372,9 @@
              output_values_2d_target(t_ind,:) = vmea(l)%measured_vars_soil(:,n)
              output_values_2d_pointer => output_values_2d_target
-             return_value =                                                    &
-                      dom_write_var( vmea(l)%nc_filename,                      &
-                                     variable_name,                            &
-                                     values_realwp_2d = output_values_2d_pointer, &
-                                     bounds_start = (/vmea(l)%start_coord_s, t_ind/), &
+             return_value =                                                                        &
+                      dom_write_var( vmea(l)%nc_filename,                                          &
+                                     variable_name,                                                &
+                                     values_realwp_2d = output_values_2d_pointer,                  &
+                                     bounds_start = (/vmea(l)%start_coord_s, t_ind/),              &
                                      bounds_end   = (/vmea(l)%end_coord_s, t_ind  /) )
              DEALLOCATE( output_values_2d_target )
@@ -2529,8 +2387,8 @@
              output_values_2d_pointer => output_values_2d_target
 
-             return_value = dom_write_var( vmea(l)%nc_filename,                &
-                                           variable_name,                      &
-                                           values_realwp_2d = output_values_2d_pointer, &
-                                           bounds_start = (/vmea(l)%start_coord_a, t_ind/), &
+             return_value = dom_write_var( vmea(l)%nc_filename,                                    &
+                                           variable_name,                                          &
+                                           values_realwp_2d = output_values_2d_pointer,            &
+                                           bounds_start = (/vmea(l)%start_coord_a, t_ind/),        &
                                            bounds_end   = (/vmea(l)%end_coord_a, t_ind/) )
 
@@ -2539,9 +2397,9 @@
              output_values_2d_target(t_ind,:) = vmea(l)%measured_vars(:,n)
              output_values_2d_pointer => output_values_2d_target
-             return_value =                                                    &
-                      dom_write_var( vmea(l)%nc_filename,                      &
-                                     variable_name,                            &
-                                     values_realwp_2d = output_values_2d_pointer, &
-                                     bounds_start = (/ vmea(l)%start_coord_a, t_ind /), &
+             return_value =                                                                        &
+                      dom_write_var( vmea(l)%nc_filename,                                          &
+                                     variable_name,                                                &
+                                     values_realwp_2d = output_values_2d_pointer,                  &
+                                     bounds_start = (/ vmea(l)%start_coord_a, t_ind /),            &
                                      bounds_end   = (/ vmea(l)%end_coord_a, t_ind /) )
 
